﻿Public Class Form1
    #Region "Class CmbBoxData : コンボボックス用."
        Friend Class CmbBoxData
            Friend Name As String
            Friend DataNo As Integer
            Friend Index As Integer

            Public Overrides Function ToString() As String
                Return Name
            End Function
        End Class
    #End Region

    #Region "変数."
        Friend PS As New NSDPrinterSetting
        Friend StrCls_PrinterName As String = Nothing   ' プリンタ名.
        Dim BlnCls_PrinterChange As Boolean = False     ' プリンタの変更.
    #End Region

    #Region "Sub ErrMsg : エラーの表示."
        Friend Sub ErrMsg()
            Try
                Select Case PS.GetLastDllErr 
                    Case NSDPrinterSetting.ERROR_ACCESS_DENIED
                        Call MsgBox("アクセスが拒否されました。")
                    Case Else
                        Call MsgBox("失敗しました。")
                End Select
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Form1_FormClosing : FormClosingイベント."
        Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
            Try
                ' 解放処理.
                PS.Dispose
                PS = Nothing
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Form1_Load : Loadイベント."
        Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
            Try

                ' ----------------------------------
                ' ポート名のリストを取得します.
                ' ----------------------------------
                Dim Strc_PortList As NSDPrinterSetting.PORT_LIST = Nothing
                With Me.Cmb_Port
                    .Items.Clear
                    If PS.GetPortList(Strc_PortList) Then
                        For Int_Loop As Integer = 0 To Strc_PortList.Int_Count - 1
                            ' ポート名をセットします.
                            .Items.Add(Strc_PortList.Str_PortName(Int_Loop))
                        Next Int_Loop
                    End If
                End With

                ' ----------------------------------
                ' プリンタのリストを取得します.
                ' ----------------------------------
                Dim Str_PrinterName() As String = Nothing   ' プリンタ名.
                With Me.Cmb_PrinterName
                    .Items.Clear
                    If PS.GetPrinterList(Str_PrinterName) Then
                        ' 通常使用するプリンタを初期化.
                        Dim Int_Default As Integer = -1
                        For Int_Loop As Integer = 0 To Str_PrinterName.Length - 1
                            ' プリンタ名をセットします.
                            .Items.Add(Str_PrinterName(Int_Loop))

                            Dim Bln_Default As Boolean  ' 通常使用するプリンタの確認用.
                            If PS.IsDefault(Str_PrinterName(Int_Loop), Bln_Default) Then
                                If Bln_Default Then
                                    ' 通常使用するプリンタを確認.
                                    Int_Default = Int_Loop
                                End If
                            End IF
                        Next Int_Loop
                        If Int_Default <> -1 Then
                            ' 通常使用するプリンタをセット.
                            .SelectedItem = .Items(Int_Default)
                        End If
                    End If
                End With
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Cmb_PrinterName_SelectedIndexChanged : プリンタの選択."
        Private Sub Cmb_PrinterName_SelectedIndexChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Cmb_PrinterName.SelectedIndexChanged
            Try
                Cmb_PrinterName_SelectedIndexChanged_Sub
            Catch ex As Exception
            Finally
            End Try
        End Sub

        #Region "Sub Cmb_PrinterName_SelectedIndexChanged_Sub : プリンタの選択."
            Private Sub Cmb_PrinterName_SelectedIndexChanged_Sub()
                Try
                    ' 通常使用するプリンタ.
                    Dim Bln_Defalut As Boolean = False

                    ' プリンタの変更ON.
                    BlnCls_PrinterChange = True

                    ' プリンタ名の取得.
                    StrCls_PrinterName = Me.Cmb_PrinterName.Text

                    ' 通常使用するプリンタ.
                    Me.Chk_Default.Enabled = True
                    If PS.IsDefault(StrCls_PrinterName, Bln_Defalut) Then
                        Me.Chk_Default.Checked = Bln_Defalut
                        If Bln_Defalut Then
                            Me.Chk_Default.Enabled = False
                        End If
                    End If

                    ' オンライン状態.
                    Dim Bln_OnLine As Boolean
                    If PS.IsOnLine(StrCls_PrinterName, Bln_OnLine) Then
                        Me.Chk_OnLine.Checked = Bln_OnLine
                    End If

                    ' 双方向サポートを有効にする.
                    Dim Bln_BIDI As Boolean
                    If PS.IsENABLE_BIDI(StrCls_PrinterName, Bln_BIDI) Then
                        Me.Chk_BIDI.Checked = Bln_BIDI
                    End If

                    ' 出力ポート名をセットします.
                    Dim Str_PortName As String = PS.GetOutPort(StrCls_PrinterName)
                    With Me.Cmb_Port
                        .SelectedItem = Nothing
                        For Int_Loop As Integer = 0 To .Items.Count - 1
                            If .Items(Int_Loop) = Str_PortName Then
                                ' ポート名を選択します.
                                .SelectedItem = .Items(Int_Loop)
                                Exit For
                            End If
                        Next Int_Loop
                    End With

                    ' 印刷ドキュメントのスプール.
                    Dim Bln_Direct As Boolean
                    If PS.IsDirect(StrCls_PrinterName, Bln_Direct) Then
                        If Bln_Direct Then
                            Me.RB_Direct2.Checked = True
                        Else
                            Me.RB_Direct1.Checked = True
                        End If
                    End If

                    ' 全ページ分のデータをスプールしてから、印刷データをプリンタに送る.
                    Dim Bln_QUEUED As Boolean
                    If PS.IsQUEUED(StrCls_PrinterName, Bln_QUEUED) Then
                        If Bln_QUEUED Then
                            Me.RB_QUEUED1.Checked = True
                        Else
                            Me.RB_QUEUED2.Checked = True
                        End If
                    End If

                    ' 一致しないドキュメントを保留する.
                    Dim Bln_ENABLE_DEVQ As Boolean
                    If PS.IsENABLE_DEVQ(StrCls_PrinterName, Bln_ENABLE_DEVQ) Then
                        Me.Chk_ENABLE_DEVQ.Checked = Bln_ENABLE_DEVQ
                    End If

                    ' スプールされたドキュメントを最初に印刷する.
                    Dim Bln_DO_COMPLETE_FIRST As Boolean
                    If PS.IsDO_COMPLETE_FIRST(StrCls_PrinterName, Bln_DO_COMPLETE_FIRST) Then
                        Me.Chk_DO_COMPLETE_FIRST.Checked = Bln_DO_COMPLETE_FIRST
                    End If

                    ' 印刷後ドキュメントを残す.
                    Dim Bln_KEEPPRINTEDJOBS As Boolean
                    If PS.IsKEEPPRINTEDJOBS(StrCls_PrinterName, Bln_KEEPPRINTEDJOBS) Then
                        Me.Chk_KEEPPRINTED_JOBS.Checked = Bln_KEEPPRINTEDJOBS
                    End If

                    ' 詳細な印刷機能を有効にする.
                    Dim Bln_RAW_ONLY As Boolean
                    If PS.IsRAW_ONLY(StrCls_PrinterName, Bln_RAW_ONLY) Then
                        Me.Chk_RAW_ONLY.Checked = Not Bln_RAW_ONLY
                    End If

                    ' 出力可能な用紙.
                    Dim Str_PaperName() As String = Nothing
                    Dim Int_PaperSize() As Integer = Nothing
                    If PS.GetPaperName(StrCls_PrinterName, Str_PaperName, Int_PaperSize) Then
                        If Not (Str_PaperName Is Nothing) Then
                            With Me.Cmb_PaperName
                                .Items.Clear

                                For Int_Loop As Integer = 0 To Str_PaperName.Length - 1
                                    Dim CB_Item As New CmbBoxData

                                    CB_Item.Name = Str_PaperName(Int_Loop)
                                    CB_Item.DataNo = Int_PaperSize(Int_Loop)
                                    CB_Item.Index = Int_Loop

                                    .Items.Add(CB_Item)
                                Next Int_Loop
                            End With
                        End If
                    End If

                    ' 現在選択している用紙を取得.
                    Dim Int_SelectPaperSize As Integer
                    Dim Str_SelectPaperSize As String = ""
                    If PS.GetPaperSize(StrCls_PrinterName, Int_SelectPaperSize, Str_SelectPaperSize) Then
                        With Me.Cmb_PaperName
                            For Int_Loop As Integer = 0 To .Items.Count - 1
                                If .Items(Int_Loop).ToString = Str_SelectPaperSize Then
                                    .SelectedItem = .Items(Int_Loop)
                                    Exit For
                                End If
                            Next Int_Loop
                        End With
                    End If

                    ' 利用可能な用紙.
                    If PS.GetMediaRady(StrCls_PrinterName, Str_PaperName) Then
                        If Not (Str_PaperName Is Nothing) Then
                            With Me.Cmb_MediaReday
                                .Items.Clear

                                For Int_Loop As Integer = 0 To Str_PaperName.Length - 1
                                    Dim CB_Item As New CmbBoxData

                                    CB_Item.Name = Str_PaperName(Int_Loop)
                                    CB_Item.DataNo = 0
                                    CB_Item.Index = Int_Loop

                                    .Items.Add(CB_Item)
                                Next Int_Loop
                            End With
                        End If
                    End If

                    ' 構成データの取得.
                    Me.ListBox1.Items.Clear()
                    Dim Cls_PrintData() As NSDPrinterSetting.NSDPrintData = Nothing
           
                    If PS.GetPrinterData(StrCls_PrinterName, Cls_PrintData) Then
                        With Me.ListBox1
                            For Int_Loop As Integer = 0 To Cls_PrintData.Length - 1
                                Dim Str_Data As String = Nothing
                                Str_Data &= Cls_PrintData(Int_Loop).DataName & " ："
                                Select Case Cls_PrintData(Int_Loop).DataType
                                    Case NSDPrinterSetting.NSDRegType.REG_DWORD
                                        Str_Data &= " " & Cls_PrintData(Int_Loop).DataValue.ToString()
                                    Case NSDPrinterSetting.NSDRegType.REG_SZ
                                        Str_Data &= " " & Cls_PrintData(Int_Loop).DataValue
                                    Case NSDPrinterSetting.NSDRegType.REG_MULTI_SZ
                                        Dim Str_OneData As String = Nothing
                                        For Int_Loop2 As Integer = 0 To Cls_PrintData(Int_Loop).DataValue.Length - 1
                                            If Not String.IsNullOrEmpty(Str_OneData) Then
                                                Str_OneData &= " "
                                            End If
                                            Str_OneData &= Cls_PrintData(Int_Loop).DataValue(Int_Loop2)
                                        Next

                                        Str_Data &= " " & Str_OneData
                                    Case Else
                                        Str_Data &= " Size=" & Cls_PrintData(Int_Loop).DataValue.Length.ToString()
                                End Select
                                .Items.Add(Str_Data)
                            Next
                        End With
                    End If

                Catch ex As Exception
                Finally
                    ' プリンタの変更OFF.
                    BlnCls_PrinterChange = False
                End Try
            End Sub
        #End Region
    #End Region

    #Region "Sub Chk_Default_CheckedChanged : 通常使用するプリンタ."
        Private Sub Chk_Default_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Chk_Default.CheckedChanged
            Try
                If Not BlnCls_PrinterChange Then
                    If Not PS.SetDefault(StrCls_PrinterName) Then
                        ErrMsg
                    End If
                    Cmb_PrinterName_SelectedIndexChanged_Sub
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Chk_OnLine_CheckedChanged : オンライン."
        Private Sub Chk_OnLine_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Chk_OnLine.CheckedChanged
            Try
                If Not BlnCls_PrinterChange Then
                    If Not PS.SetOnLine( StrCls_PrinterName, Me.Chk_OnLine.Checked) Then
                        ErrMsg
                    End If
                    Cmb_PrinterName_SelectedIndexChanged_Sub
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Chk_BIDI_CheckedChanged : 双方向サポートを有効にする."
        Private Sub Chk_BIDI_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Chk_BIDI.CheckedChanged
            Try
                If Not BlnCls_PrinterChange Then
                    If Not PS.SetENABLE_BIDI( StrCls_PrinterName, Me.Chk_BIDI.Checked) Then
                        ErrMsg
                    End If
                    Cmb_PrinterName_SelectedIndexChanged_Sub
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_State_Click : 状態設定."
        Private Sub Btn_State_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_State.Click
            Try
                Using fm As New Form2
                    fm.ShowDialog
                End Using
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Cmb_Port_SelectedIndexChanged : 出力ポートの変更."
        Private Sub Cmb_Port_SelectedIndexChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Cmb_Port.SelectedIndexChanged
            Try
                Cmb_Port_SelectedIndexChanged_Sub
            Catch ex As Exception
            Finally
            End Try
        End Sub

        #Region "Sub Cmb_Port_SelectedIndexChanged_Sub : 出力ポート名の変更."
            Private Sub Cmb_Port_SelectedIndexChanged_Sub()
                Try
                    If Not BlnCls_PrinterChange Then
                        ' 出力ポート名の変更.
                        Dim Str_PortName As String = Me.Cmb_Port.Text

                        If Not PS.ChangeOutPort(StrCls_PrinterName, Str_PortName) Then
                            ErrMsg
                        End If
                        Cmb_PrinterName_SelectedIndexChanged_Sub
                    End If
                Catch ex As Exception
                Finally
                End Try
            End Sub
        #End Region
    #End Region

    #Region "Sub Btn_JobCount_Click : 印刷ジョブの件数."
        Private Sub Btn_JobCount_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_JobCount.Click
            Try
                Dim Int_Count As Integer
                If PS.JobCount(StrCls_PrinterName, Int_Count) Then
                    MsgBox("印刷ジョブ数:" & Convert.ToString(Int_Count))
                Else
                    ErrMsg
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_JobInfo_Click : 印刷ジョブの情報."
        Private Sub Btn_JobInfo_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_JobInfo.Click
            Try
                Using fm As New Form4
                    fm.ShowDialog
                End Using
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_JobDelete_Click : 印刷ジョブの削除."
        Private Sub Btn_JobDelete_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_JobDelete.Click
            Try
                If Not PS.DeleteJob(StrCls_PrinterName, -1) Then
                    ErrMsg
                Else
                    MsgBox("印刷ジョブを削除しました.")
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub RB_Direct1_CheckedChanged : 印刷ドキュメントをスプールし、プログラムの印刷処理を高速に行う."
        Private Sub RB_Direct1_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles RB_Direct1.CheckedChanged
            Try
                RB_Direct1_2_CheckedChanged( sender, True) 
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub RB_Direct2_CheckedChanged : プリンタに直接印刷データを送る."
        Private Sub RB_Direct2_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles RB_Direct2.CheckedChanged
            Try
                RB_Direct1_2_CheckedChanged( sender, False) 
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub RB_Direct1_2_CheckedChanged : RB_Direct1、RB_Direct2のCheckedChanged処理."
        Private Sub RB_Direct1_2_CheckedChanged(ByRef sender As System.Object, ByVal BlnVal_Enabled As Boolean) 
            Try
                If CType(sender, RadioButton).Checked Then
                    If Not BlnCls_PrinterChange Then
                        If Not PS.SetDirect(StrCls_PrinterName, Not BlnVal_Enabled, True) Then
                            ErrMsg
                        End If
                        Cmb_PrinterName_SelectedIndexChanged_Sub
                    End If
                    Me.Panel1.Enabled = BlnVal_Enabled
                    Me.Chk_ENABLE_DEVQ.Enabled = BlnVal_Enabled
                    Me.Chk_DO_COMPLETE_FIRST.Enabled = BlnVal_Enabled
                    Me.Chk_KEEPPRINTED_JOBS.Enabled = BlnVal_Enabled
                    Me.Chk_RAW_ONLY.Enabled = BlnVal_Enabled
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Form_Click : 用紙."
        Private Sub Btn_Form_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Form.Click
            Try
                Using fm As New Form3
                    fm.ShowDialog
                End Using
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Cmb_PaperName_SelectedIndexChanged : 出力可能な用紙."
        Private Sub Cmb_PaperName_SelectedIndexChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Cmb_PaperName.SelectedIndexChanged
            Try
                If Not BlnCls_PrinterChange Then
                    Cmb_PaperName_SelectedIndexChanged_Sub
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub

        #Region "Sub Cmb_PaperName_SelectedIndexChanged_Sub : 出力可能な用紙."
            Private Sub Cmb_PaperName_SelectedIndexChanged_Sub()
                Try
                    With Me.Cmb_PaperName
                        Dim Item As CmbBoxData = .Items(.SelectedIndex)
                        Dim Int_PaperSize As Integer = Item.DataNo
                        If Not PS.SetPaperSize(StrCls_PrinterName, Int_PaperSize) Then
                            ErrMsg
                        End If
                        Cmb_PrinterName_SelectedIndexChanged_Sub
                    End With
                Catch ex As Exception
                Finally
                End Try
            End Sub
        #End Region
    #End Region

    #Region "Sub RB_QUEUED1_CheckedChanged : 全ページ分のデータをスプールしてから、印刷データをプリンタに送る."
        Private Sub RB_QUEUED1_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles RB_QUEUED1.CheckedChanged
            Try
                If Not BlnCls_PrinterChange Then
                    RB_QUEUED1_2_CheckedChanged(True)
                End If
            Catch ex As Exception
            Finally
            End Try    
        End Sub
    #End Region

    #Region "Sub RB_QUEUED2_CheckedChanged : すぐに印刷データをプリンタに送る."
        Private Sub RB_QUEUED2_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles RB_QUEUED2.CheckedChanged
            Try
                If Not BlnCls_PrinterChange Then
                    RB_QUEUED1_2_CheckedChanged(False)
                End If
            Catch ex As Exception
            Finally
            End Try    
        End Sub

        #Region "Sub RB_QUEUED1_2_CheckedChanged : すぐに印刷データをプリンタに送る."
            Private Sub RB_QUEUED1_2_CheckedChanged( ByVal BlnVal_QUEUED As Boolean)
                Try
                    If Not PS.SetQUEUED(StrCls_PrinterName, BlnVal_QUEUED) Then
                        ErrMsg
                    End If
                    Cmb_PrinterName_SelectedIndexChanged_Sub
                Catch ex As Exception
                Finally
                End Try    
            End Sub
        #End Region
    #End Region

    #Region "Sub Chk_ENABLE_DEVQ_CheckedChanged : 一致しないドキュメントを保留する."
        Private Sub Chk_ENABLE_DEVQ_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Chk_ENABLE_DEVQ.CheckedChanged
            Try
                If Not BlnCls_PrinterChange Then
                    If Not PS.SetENABLE_DEVQ( StrCls_PrinterName, Me.Chk_ENABLE_DEVQ.Checked) Then
                        ErrMsg
                    End If
                    Cmb_PrinterName_SelectedIndexChanged_Sub
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Chk_DO_COMPLETE_FIRST_CheckedChanged : スプールされたドキュメントを最初に印刷する."
        Private Sub Chk_DO_COMPLETE_FIRST_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Chk_DO_COMPLETE_FIRST.CheckedChanged
            Try
                If Not BlnCls_PrinterChange Then
                    If Not PS.SetDO_COMPLETE_FIRST( StrCls_PrinterName, Me.Chk_DO_COMPLETE_FIRST.Checked) Then
                        ErrMsg
                    End If
                    Cmb_PrinterName_SelectedIndexChanged_Sub
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Chk_KEEPPRINTED_JOBS_CheckedChanged : 印刷後ドキュメントを残す."
        Private Sub Chk_KEEPPRINTED_JOBS_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Chk_KEEPPRINTED_JOBS.CheckedChanged
            Try
                If Not BlnCls_PrinterChange Then
                    If Not PS.SetKEEPPRINTEDJOBS( StrCls_PrinterName, Me.Chk_KEEPPRINTED_JOBS.Checked) Then
                        ErrMsg
                    End If
                    Cmb_PrinterName_SelectedIndexChanged_Sub
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Chk_RAW_ONLY_CheckedChanged : 詳細な印刷機能を有効にする."
        Private Sub Chk_RAW_ONLY_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Chk_RAW_ONLY.CheckedChanged
            Try
                If Not BlnCls_PrinterChange Then
                    If Not PS.SetRAW_ONLY( StrCls_PrinterName, Not Me.Chk_RAW_ONLY.Checked) Then
                        ErrMsg
                    End If
                    Cmb_PrinterName_SelectedIndexChanged_Sub
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Property_Click : プリンターのプロパティを表示します."
        Private Sub Btn_Property_Click( sender As System.Object,  e As System.EventArgs) Handles Btn_Property.Click
            Try
                PS.ShowPrinterProperty(StrCls_PrinterName, Me.Handle)
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region
End Class
