﻿Public Class Form3
    #Region "変数."
        Dim StrcCls_FormList() As NSDPrinterSetting.FORM_INFO_1 = Nothing
        Dim CtrlCls_Lbl_Size(0 To 1) As Label               ' lbl_Size1、lbl_Size2
        Dim CtrlCls_Txt_Size(0 To 1) As TextBox             ' Txt_Size1、Txt_Size2

        Dim CtrlCls_Lbl_ImageableArea(0 To 3) As Label      ' Lbl_ImageableArea1～Lbl_ImageableArea4
        Dim CtrlCls_Txt_ImageableArea(0 To 3) As TextBox    ' Txt_ImageableArea1～Txt_ImageableArea4
    #End Region

    #Region "Class ListBoxData : リストボックス用."
        Friend Class ListBoxData
            Friend Name As String
            Friend Index As Integer

            Public Overrides Function ToString() As String
                Return Name
            End Function
        End Class
    #End Region

    #Region "Sub PaperSet : 用紙をセットします."
        Private Sub PaperSet()
            Try
                With Form1
                    ' 用紙のリストを取得します.
                    If Not .PS.GetFormsList(.StrCls_PrinterName, StrcCls_FormList, NSDPrinterSetting.FORM.FORM_ALL) Then
                        .ErrMsg
                    Else
                        If Not (StrcCls_FormList Is Nothing) Then
                            With Me.Lb_Form
                                ' リストボックスをクリアします.
                                .Items.Clear
                                For Int_Loop As Integer = 0 To StrcCls_FormList.Length - 1
                                    Dim LB As New ListBoxData

                                    ' 用紙名をセットします.
                                    LB.Name = StrcCls_FormList(Int_Loop).pName
                                    ' バッファのインデックスをセットします.
                                    LB.Index = Int_Loop

                                    ' 用紙をセットします.
                                    .Items.Add(LB)
                                Next Int_Loop
                                If .Items.Count <> 0 Then
                                    .SelectedItem = .Items(0)
                                End If
                            End With
                        End If
                    End If
                End With
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Form3_FormClosing : FormClosingイベント."
        Private Sub Form3_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
            Try
                For Int_Loop As Integer = 0 To 1
                    CtrlCls_Lbl_Size(Int_Loop) = Nothing
                    CtrlCls_Txt_Size(Int_Loop) = Nothing
                Next Int_Loop

                For Int_Loop As Integer = 0 To 3
                    CtrlCls_Lbl_ImageableArea(Int_Loop) = Nothing
                    CtrlCls_Txt_ImageableArea(Int_Loop) = Nothing
                Next Int_Loop
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Form3_Load : Loadイベント."
        Private Sub Form3_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
            Try
                ' コントロールを配列にセット.
                CtrlCls_Lbl_Size(0) = Me.Lbl_Size1
                CtrlCls_Lbl_Size(1) = Me.Lbl_Size2

                CtrlCls_Txt_Size(0) = Me.Txt_Size1
                CtrlCls_Txt_Size(1) = Me.Txt_Size2

                CtrlCls_Lbl_ImageableArea(0) = Me.Lbl_ImageableArea1
                CtrlCls_Lbl_ImageableArea(1) = Me.Lbl_ImageableArea2
                CtrlCls_Lbl_ImageableArea(2) = Me.Lbl_ImageableArea3
                CtrlCls_Lbl_ImageableArea(3) = Me.Lbl_ImageableArea4

                CtrlCls_Txt_ImageableArea(0) = Me.Txt_ImageableArea1
                CtrlCls_Txt_ImageableArea(1) = Me.Txt_ImageableArea2
                CtrlCls_Txt_ImageableArea(2) = Me.Txt_ImageableArea3
                CtrlCls_Txt_ImageableArea(3) = Me.Txt_ImageableArea4

                ' 用紙をセットします.
                PaperSet
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Lb_Form_SelectedIndexChanged : 用紙の選択."
        Private Sub Lb_Form_SelectedIndexChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Lb_Form.SelectedIndexChanged
            Try
                Lb_Form_SelectedIndexChanged_Sub
            Catch ex As Exception
            Finally
            End Try
        End Sub

        #Region "Sub Lb_Form_SelectedIndexChanged_Sub : 用紙の選択."
            Private Sub Lb_Form_SelectedIndexChanged_Sub()
                Try
                    Dim Bln_Enabled As Boolean = True
                    With Form1
                        Dim Str_Name As String = Me.Lb_Form.SelectedItem.ToString   ' 用紙名.
                        Dim Strc_FORM_INFO_1 As NSDPrinterSetting.FORM_INFO_1 = Nothing

                        Me.Txt_Form.Text = Str_Name

                        ' 用紙の情報を取得します.
                        If .PS.GetForm(.StrCls_PrinterName, Str_Name, Strc_FORM_INFO_1) Then
                            Dim Item As New ListBoxData 
                            Item = Me.Lb_Form.SelectedItem

                            StrcCls_FormList(Item.Index) = Strc_FORM_INFO_1

                            Dim Str_Flag As String = ""
                            Select Case Strc_FORM_INFO_1.Flags
                                Case NSDPrinterSetting.FORM.FORM_USER
                                    Str_Flag = "ユーザー定義"
                                Case NSDPrinterSetting.FORM.FORM_BUILTIN
                                    Str_Flag = "スプーラ定義"
                                    Bln_Enabled = False
                                Case NSDPrinterSetting.FORM.FORM_PRINTER
                                    Str_Flag = "プリンタ定義"
                                Case Else
                                    Str_Flag = "不明"
                            End Select
                            Me.Lbl_Flag.Text = "特性：" & Str_Flag

                            ' サイズをセット.
                            Me.Txt_Size1.Text = .PS.GetFormSizeValue(Me.RB_Unit1.Checked, Strc_FORM_INFO_1.Size.cx)
                            Me.Txt_Size2.Text = .PS.GetFormSizeValue(Me.RB_Unit1.Checked, Strc_FORM_INFO_1.Size.cy)

                            ' 余白をセット.
                            .PS.ConvertImageableAreaIntoMargin(Strc_FORM_INFO_1.ImageableArea, Strc_FORM_INFO_1.Size)
                            Me.Txt_ImageableArea1.Text = .PS.GetFormSizeValue(Me.RB_Unit1.Checked, Strc_FORM_INFO_1.ImageableArea.Left)
                            Me.Txt_ImageableArea2.Text = .PS.GetFormSizeValue(Me.RB_Unit1.Checked, Strc_FORM_INFO_1.ImageableArea.Top)
                            Me.Txt_ImageableArea3.Text = .PS.GetFormSizeValue(Me.RB_Unit1.Checked, Strc_FORM_INFO_1.ImageableArea.Right)
                            Me.Txt_ImageableArea4.Text = .PS.GetFormSizeValue(Me.RB_Unit1.Checked, Strc_FORM_INFO_1.ImageableArea.Bottom)
                        Else
                            Bln_Enabled = False
                        End If

                        Me.Lbl_Name.Enabled = False
                        Me.Txt_Form.Enabled = False

                        For Int_Loop As Integer = 0 To 1
                            CtrlCls_Lbl_Size(Int_Loop).Enabled = Bln_Enabled
                            CtrlCls_Txt_Size(Int_Loop).Enabled = Bln_Enabled
                        Next Int_Loop

                        For Int_Loop As Integer = 0 To 3
                            CtrlCls_Lbl_ImageableArea(Int_Loop).Enabled = Bln_Enabled
                            CtrlCls_Txt_ImageableArea(Int_Loop).Enabled = Bln_Enabled
                        Next Int_Loop

                        Me.Btn_Delete.Enabled = Bln_Enabled
                        Me.Btn_Write.Enabled = Bln_Enabled

                        Me.Chk_NewForm.Checked = False
                    End With
                Catch ex As Exception
                Finally
                End Try
            End Sub
        #End Region
    #End Region

    #Region "Sub Btn_Write_Click : 用紙の保存."
        Private Sub Btn_Write_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Write.Click
            Try
                Dim Strc_FORM_INFO_1 As NSDPrinterSetting.FORM_INFO_1 = Nothing
                Dim Strc_New_FORM_INFO_1 As NSDPrinterSetting.FORM_INFO_1 = Nothing

                Do
                    With Strc_New_FORM_INFO_1
                        ' 名前.
                        .pName = Me.Txt_Form.Text.Trim()

                        ' 特性.
                        .Flags = 0

                        ' サイズ.
                        .Size.cx = Form1.PS.SetFormSizeValue(Me.RB_Unit1.Checked, Me.Txt_Size1.Text)
                        .Size.cy = Form1.PS.SetFormSizeValue(Me.RB_Unit1.Checked, Me.Txt_Size2.Text)

                        ' 余白をセット.
                        .ImageableArea.Left = Form1.PS.SetFormSizeValue(Me.RB_Unit1.Checked, Me.Txt_ImageableArea1.Text)
                        .ImageableArea.Top = Form1.PS.SetFormSizeValue(Me.RB_Unit1.Checked, Me.Txt_ImageableArea2.Text)
                        .ImageableArea.Right = Form1.PS.SetFormSizeValue(Me.RB_Unit1.Checked, Me.Txt_ImageableArea3.Text)
                        .ImageableArea.Bottom = Form1.PS.SetFormSizeValue(Me.RB_Unit1.Checked, Me.Txt_ImageableArea4.Text)

                        ' 余白を印刷可能領域に変換します.
                        Form1.PS.ConvertMarginIntoImageableArea(.ImageableArea, .Size)
                        If Not Form1.PS.IsOkImageableArea(.Size, .ImageableArea) Then
                            MsgBox("印刷可能領域が異常です。")
                            Exit Do
                        End If
                    End With

                    If Me.Chk_NewForm.Checked Then
                        ' 新しい用紙を追加します.
                        If Form1.PS.GetForm(Form1.StrCls_PrinterName, Me.Txt_Form.Text, Strc_FORM_INFO_1) Then
                            ' 既に同一名の用紙が存在します.
                            MsgBox("既に同一名の用紙が存在します。")
                        Else
                            With Strc_New_FORM_INFO_1
                                If Form1.PS.AddForm(Form1.StrCls_PrinterName, Me.Txt_Form.Text.Trim, .Size , .ImageableArea) Then
                                    MsgBox("用紙を追加しました。")
                                    ' 用紙をセットします.
                                    PaperSet
                                Else
                                    Form1.ErrMsg
                                End If
                            End With
                        End If
                    Else
                        ' 変更.
                        If Form1.PS.SetForm(Nothing, Strc_New_FORM_INFO_1) Then
                            MsgBox("用紙を変更しました.")
                        Else
                            Form1.ErrMsg
                        End If
                    End If
                Loop While (0)
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Delete_Click : 用紙の削除."
        Private Sub Btn_Delete_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Delete.Click
            Try
                With Me.Lb_Form
                    If Not (.SelectedItem Is Nothing) Then
                        Dim Str_Msg As String = "用紙「" & .SelectedItem.ToString & "」を削除します。"
                        Str_Msg &= ControlChars.CrLf & "よろしいですか？"
                        If MsgBox(Str_Msg,MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                            If Form1.PS.DeleteForm(Nothing, .SelectedItem.ToString) Then
                                MsgBox("削除しました。")
                            Else
                                Form1.ErrMsg
                            End If
                            ' 用紙をセットします.
                            PaperSet
                        End If
                    Else
                        MsgBox("削除する用紙が選択されていません。")
                    End If
                End With
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Chk_NewForm_CheckedChanged : 新しい用紙を作成する."
        Private Sub Chk_NewForm_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Chk_NewForm.CheckedChanged
            Try
                If Me.Chk_NewForm.Checked Then
                    Me.Lbl_Name.Enabled = True
                    Me.Txt_Form.Enabled = True

                    Me.Btn_Delete.Enabled = False
                    Me.Btn_Write.Enabled = True

                    For Int_Loop As Integer = 0 To 1
                        CtrlCls_Lbl_Size(Int_Loop).Enabled = True
                        CtrlCls_Txt_Size(Int_Loop).Enabled = True
                    Next Int_Loop

                    For Int_Loop As Integer = 0 To 3
                        CtrlCls_Lbl_ImageableArea(Int_Loop).Enabled = True
                        CtrlCls_Txt_ImageableArea(Int_Loop).Enabled = True
                    Next Int_Loop
                Else
                    Lb_Form_SelectedIndexChanged_Sub
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub RB_Unit1_CheckedChanged : メートル法."
        Private Sub RB_Unit1_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles RB_Unit1.CheckedChanged
            Try
                RB_Unit1_2_CheckedChanged(True)
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub RB_Unit2_CheckedChanged : ヤードポンド法."
        Private Sub RB_Unit2_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles RB_Unit2.CheckedChanged
            Try
                RB_Unit1_2_CheckedChanged(False)
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub RB_Unit1_2_CheckedChanged : メートル法またはヤードポンド法の切り替え."
        Private Sub RB_Unit1_2_CheckedChanged(ByVal BlnVal_Unit1 As Boolean)
            Try
                If Not (Me.Lb_Form.SelectedItem Is Nothing) Then
                    Dim Item As New ListBoxData 
                    Item = Me.Lb_Form.SelectedItem

                    Dim Strc_FormList As NSDPrinterSetting.FORM_INFO_1 = StrcCls_FormList(Item.Index)

                    With Form1
                        ' サイズをセット.
                        Me.Txt_Size1.Text = .PS.GetFormSizeValue(BlnVal_Unit1, Strc_FormList.Size.cx)
                        Me.Txt_Size2.Text = .PS.GetFormSizeValue(BlnVal_Unit1, Strc_FormList.Size.cy)

                        ' 余白をセット.
                        .PS.ConvertImageableAreaIntoMargin(Strc_FormList.ImageableArea, Strc_FormList.Size)
                        Me.Txt_ImageableArea1.Text = .PS.GetFormSizeValue(BlnVal_Unit1, Strc_FormList.ImageableArea.Left)
                        Me.Txt_ImageableArea2.Text = .PS.GetFormSizeValue(BlnVal_Unit1, Strc_FormList.ImageableArea.Top)
                        Me.Txt_ImageableArea3.Text = .PS.GetFormSizeValue(BlnVal_Unit1, Strc_FormList.ImageableArea.Right)
                        Me.Txt_ImageableArea4.Text = .PS.GetFormSizeValue(BlnVal_Unit1, Strc_FormList.ImageableArea.Bottom)
                    End With
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

End Class